def get_solver_callstring(instance_filename, seed, param_hashmap)
	randnum = rand
	input_file_to_write = "callstring_inputs_#{randnum}.csv"
	output_file_to_read = "generated_callstring_#{randnum}.txt"

	#=== Write input file for external script.
	File.open(input_file_to_write, "w"){|file|
		file.puts instance_filename
		file.puts seed
        	for param_name in param_hashmap.keys
	        	param_value = param_hashmap[param_name]
	        	file.puts "#{param_name}, #{param_value}"
		end
	}

	#=== Call external script
	cmd = "get_callstring_for_inputs #{input_file_to_write} > #{output_file_to_read}"
	puts "callstring_generator.rb is calling external script to get callstring via command: #{cmd}"
	system cmd

	#=== Parse result of external script (the last line is what counts).
	solver_callstring = nil
	begin
		File.open(output_file_to_read){|file|
			while line = file.gets
				solver_callstring = line
			end
		}
	rescue
	end
	
	#=== Return parsed result.
	unless solver_callstring
		puts "Error generating callstring with about command. callstring_generator.rb is exiting with error."
		exit -1
	end

	File.delete(input_file_to_write)
	File.delete(output_file_to_read)
	return solver_callstring
end
